#ifndef BOSS_H
#define BOSS_H

#include <cpctelera.h>
#include "Cell.h"
#include "GameTypes.h"
#include "Interactable.h"
#include "Object.h"
#include "Timer.h"
#include "sprites/BossSprites.h"

#define BOSS_STATE_DEAD 0
#define BOSS_STATE_ACTIVE 1
#define BOSS_STATE_TELEPORTING 2

typedef struct Boss Boss;

struct Boss
{
    Object object;
    u16 timer;
    i8 health;
    u8 redraw;
	u8 state;
	u8 attack;
};

extern Boss gameBoss;

//initialises the boss values for the last level
void initBoss(u8* bossSegment);

//draws the boss on the last level
void drawBoss();

//updates mapCells for the boss' current position using the specified value
void updateBossPositionCells(u8 cellType);

//determine boss position following a teleport
void moveBossPosition();

//update the mapCells where the boss was and redraws them
void updatePreviousBossCells();

//run any logic for the boss
void logicBoss();

//indicates where boss is teleporting to
void displayTeleportDestination();

//cleanup the area after the boss is killed
void cleanupSegment();

#endif