#ifndef CELL_H
#define CELL_H

#include <cpctelera.h>
#include "GameState.h"
#include "GameTypes.h"
#include "sprites/TileSprites.h"
#include "sprites/ItemSprites.h"
#include "sprites/InteractableSprites.h"
#include "Tile.h"

#define CELL_TYPE_EMPTY 0
#define CELL_TYPE_TILE 1
#define CELL_TYPE_ITEM 2
#define CELL_TYPE_INTERACTABLE 3
#define CELL_TYPE_ENEMY 4
#define CELL_TYPE_BOSS 5

#define XY_TO_POSITION(x,y) x*SCREEN_TILES_Y + y
#define MAPA(x,y) mapCells[XY_TO_POSITION(x,y)]

typedef union Data Data;
typedef struct Cell Cell;

union Data
{
    u8 tile;
    u8 item;
	u8 interactable;
    u8 enemy;
	u8 boss;
};

struct Cell
{
    Data data;
    u8 type; //0 empty, 1 tile, 2 item, 3 interactable, 4 enemy, 5 boss
};

//240 cells in a 20x12 grid
extern Cell mapCells[240];

void initCells(u8* mapArray);

void drawCell(u8 x, u8 y, u16 position);

void drawCells();

#endif