#include "DrawQueue.h"

#define QUEUE_MAX_ 12

u8 queueCount_;
u8 queueX_[QUEUE_MAX_];
u8 queueY_[QUEUE_MAX_];

void initDrawQueue()
{
    queueCount_ = 0;
}

void addCellToDrawQueue(u8 x, u8 y)
{
	u8 i = 0;

	for (i = 0; i < queueCount_; ++i)
	{
		//if its already on the queue then dont add it
		if (queueX_[i] == x && queueY_[i] == y)
		{
			return;
		}
	}

    queueX_[queueCount_] = x;
    queueY_[queueCount_++] = y;
}

void dequeueDrawQueue()
{
    u8 i = 0;

    //draw each of the cells on the queue
    for(i=0; i<queueCount_; ++i)
    {
        drawCell(queueX_[i], queueY_[i], XY_TO_POSITION(queueX_[i], queueY_[i]));
    }

    //reset queue count to 0 after drawing all the cells
    queueCount_ = 0;
}