#ifndef GAME_H
#define GAME_H

#include <cpctelera.h>
#include "Dialog.h"
#include "GameState.h"
#include "GameTypes.h"
#include "Hud.h"
#include "Keys.h"
#include "Map.h"
#include "Palette.h"
#include "Player.h"

//any initialisation that needs to occur before the game can start
void initGame();

//runs the game and the gameloop
void runGame();

//this is where the processing of all the game logic happens
void gameLogic();

//displays the contents of the game on the screen as it changes
void drawGame();

//interrupt handler for handling interrupts, for now to handle keyboard input only
void interruptHandler();

//read input from the player/user
void readInput();

//runs the full game sessions and manages the levels of the game
void runGameSession();

#endif